from apscheduler.schedulers.blocking import BlockingScheduler
from datetime import datetime, timedelta
import subprocess
import psutil

# 删除的脚本名
target_process_name = "数据统计"
# 日统计脚本名
day_fileName="数据统计设计.py"
# 小时统计脚本名
hour_fileName="数据统计设计.py"
# 在线车辆数
online_fileName="数据统计-在线数量，每分钟执行.py"

daytime = datetime.now().strftime("%Y-%m-%d")
def my_script():
    # 获取当前时间
    current_time = datetime.now()
    # 计算前一天的日期
    previous_day = current_time - timedelta(days=1)
    # 前一天的日期
    olddaytime=previous_day.strftime("%Y-%m-%d")
    
    subprocess.run(["python",day_fileName,"--param",olddaytime])


def my_hourly_script():
    subprocess.run(["python",hour_fileName,"--param",daytime])

# 删除进程的方法
def kill_processes_by_name(process_name):
    for process in psutil.process_iter(attrs=['pid', 'name']):
        if process.info['name'] == process_name:
            try:
                print(f"Killing process {process.info['pid']} - {process.info['name']}")
                psutil.Process(process.info['pid']).terminate()
            except psutil.NoSuchProcess:
                pass

if __name__ == '__main__':
    kill_processes_by_name(target_process_name)
    scheduler = BlockingScheduler()
    # 添加每天的定时任务
    scheduler.add_job(my_script, 'cron', hour=0, minute=0, second=1, id='id_day')
    scheduler.add_job(my_hourly_script, 'cron', minute=59, second=59, id='id_hour', replace_existing=True)

    #执行定时任务
    scheduler.start()
    
    subprocess.run(["python",online_fileName,"--param",daytime])
   