
import requests
import json
from datetime import datetime, timedelta
import hashlib
import numpy as np
import argparse
name='jesse'
inputpass='kpl..87788'


# 解算时间
parser = argparse.ArgumentParser()
parser.add_argument('--param', help='请输入参数（日期格式 年-月-日）')
# daytime = input('请输入参数（日期格式 年-月-日）：')
args = parser.parse_args()
daytime=args.param
print('你输入的解算日期:', daytime)

token=''
# 车辆信息map
carinfoMap={}
# 车辆里程和时长
carLineTimerMap={}
# 车辆的收益平台分成
carIncomeScaleMap={}
# 车辆信息的绑定id
user_idArry=[]
userInfoBindMap={}
# 公司的绑定
CompaniesMap={}
# 统计的全部车辆信息
StatisticsAllInfo=[]
# 统计的总览信息
StatisticsOverview={}

# 模拟登录 防止token变化导致无法请求
def login():
    
    a=datetime.now() - timedelta(hours=8)
    n=sha256_hash(name+','+inputpass)
    key_login=sha256_hash(n+','+a.strftime('%Y-%m-%d'))
    print(key_login)
    data={
     'req_param':{
     'key_login':key_login,
     'name':name,
     'client_time':a.strftime('%Y-%m-%d %H:%M:%S')
     },
     'task':1002,
     'task_num':1
    }
    res=obtain_server_data('1002-1','login',data)
    return res['token']

#请求当月活跃数,万红发货总数,今日活跃数
def monthNumerAndDevices():
    data={
        'req_param':{
            'system_role': '1'
        },
        'task': 5003,
        'task_num': 15,
        'token':token
        }
    
    res=obtain_server_data('5003-15','jp_query_system_view',data)   
    dev=res['devies']
    return dev['devices_active_month'],dev['devices'],dev['devices_active_today']
  
# 教练总数，学员总数,用户总司
def stuAndCoachNumber():
    data={
        'req_param':{
        },
        'task': 1002,
        'task_num': 103,
        'token':token
        }
    
    res=obtain_server_data('1002-103','query_jp_user_count',data)  
    
    return  int(res['stu_total']),int(res['coach_total']),int(res['coach_total'])+int(res['stu_total'])

# 充值记录：订单数 支付金额 收入开普勒 收入服务商 收入教练
def recharge_record_statistics(type):
    statTime,endTime=time_convert(type)
    print (statTime,endTime)
    data={
        'req_param':{
           'begin':0,
            'limit': '10',
            'system_role': '1',
           'condition':{
              'date__begin': statTime,
              'date__end':endTime
           },
           'state':[1]
        },
        'task': 5005,
        'task_num': 7,
        'token':token
        }
    
    res=obtain_server_data('5005-7','jp_query_charge_record',data)
    # 订单数  
    ordersNum=res['amount']
    print (ordersNum)
    # 开普勒收入
    kpl_income=round(float(res['earning_producer'])/100,2)
    print (kpl_income)
    # 服务商收入
    facilitator_income=round(float(float(res['earning_agent'])+float(res['earning_bind_coach']))/100,2)
    print (facilitator_income)
    # 教练商收入
    coach_income=round(float(res['earning_login_coach'])/100,2)
    print (coach_income)
    # 总额 
    total_income=coach_income+facilitator_income+kpl_income
 
    return ordersNum,kpl_income,facilitator_income,coach_income,total_income

# 过滤车辆信息
def carInfoFiltration():
    data={
        'req_param':{
           'column':['sn','hphm','date_bind_coach','id_bind_coach','id_company','id_agent','id_agent2'],
           'condition':{
           },
        },
        'task': 5001,
        'task_num': 1,
        'token':token
        }
    
    res=obtain_server_data('5001-1','jp_query_car',data)
    for row in res['result']:
        if len( row['id_bind_coach'] )>0:
           carinfoMap[row['sn']]={
               'date_bind_coach':row['date_bind_coach'],
               'hphm':row['hphm'],
               'id_company':row['id_company'],
               # 代理商绑定id
               'id_agent':row['id_agent'],
               # 公司绑定的id
               'id_agent2':row['id_agent2'],
               # 教练绑定的id
               'id_bind_coach':row['id_bind_coach']
           }
           user_idArry.append(row['id_bind_coach'])
 
       
# 车辆的里程数据
def carLineNumAndTimer(type):
    statTime,endTime=time_convert(type)
    data={
        'req_param':{
           'condition':{
              'date__begin': statTime,
              'date__end':endTime,
              'group':'sn'
           },
           'group':'sn',
           'system_role':'1'
        },
        'task': 5003,
        'task_num': 9,
        'token':token
        }
    res=obtain_server_data('5003-9','jp_query_mileage_count',data)
    for row in res['result']: 
        carLineTimerMap[row['sn']]={
            'lc': round( float(row['lc'])/1000,2),
            'seconds': round( float(row['seconds'])/3600,2)
        }
    
# 车辆的收益平台分成
def carIncomeAndScale(type):
    statTime,endTime=time_convert(type)
    data={
        'req_param':{
           'condition':{
              'date__begin': statTime,
              'date__end':endTime,
              'group':'sn'
           },
           'group':'sn',
           'system_role':'1'
        },
        'task': 5005,
        'task_num': 21,
        'token':token
        }
    res=obtain_server_data('5005-21','jp_count_benefit',data)
    for row in res['result']: 
        carIncomeScaleMap[row['sn']]={
            'money': round( float(row['money'])/100,2),
            # 平台分成
            'earning_producer': round(float(row['earning_producer'])/100,2),
            # 代理商分成
            'earning_agent': round(float(row['earning_agent'])/100,2),
            # 绑定教练分成
            'earning_bind_coach': round(float(row['earning_bind_coach'])/100,2),
            # 登录教练分成
            'earning_login_coach': round(float(row['earning_login_coach'])/100,2)
        }


# 获取车辆绑定的用户信息
def getCarinfo():
    # 去重，避免取到重复数据
    new_list = []
    for i in user_idArry:
        if i not in new_list:
            new_list.append(i)
    data={
        'req_param':{
           'page':1,
           'per_page_count':len(new_list),
           'user_ids':new_list
        },
        'task': 1002,
        'task_num': 13,
        'token':token
        }
    res=obtain_server_data('1002-13','query_users',data)
    # 返回绑定格式  键值对的形式
    for idx,id in enumerate(new_list) : 
        row=res['users'][idx]
        userInfoBindMap[id]={
            'name':row['real_name'],
            'tel':row['telephone'],
        }

# 获取全部公司的id
def getCompaniesId():
    data={
        'req_param':{
        },
        'task': 1002,
        'task_num': 21,
        'token':token
    } 
    res=obtain_server_data('1002-21','query_companies',data)
    # 返回绑定格式  键值对的形式
    for row in res['companies']: 
        CompaniesMap[row['id']]={
            # 对应键值
            'parent_list':row['parent_list'],
            # 公司名称
            'name':row['name']
        }
        
    
    
# 请求方法
def obtain_server_data(api_id,api_name,data):
    url = f'https://j.kplzj.com/api/request?n={api_id}&api={api_name}'  # 替换为你要发送POST请求的URL
    print(url)
    # 发送POST请求
    proxies = {
        'http': None,
        'https': None,
    }
    response = requests.post(url,proxies=proxies, verify=False, data=json.dumps(data,ensure_ascii=False))
    # 检查请求是否成功
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['state']==0:
            print('POST请求成功！')
            return res
    else:
        print('POST请求失败，状态码：', response.status_code)
        print('错误信息：', response.text)
    return


# 存储接口
def updata_server(api_id,data):
    url = f'http://119.96.145.175:12103/api/smart/save/{api_id}'

    
    
    response = requests.post(url, data=json.dumps(data))
    # 检查请求是否成功
    if response.status_code == 200:
        res= json.loads(response.text)
        if res['code']==0:
            print('更新成功！')
            return res
    else:
        print('POST请求失败，状态码：', response.status_code)
        print('错误信息：', response.text)
    return

# 时间格式转换
def time_convert(type):
    # 获取当前日期和时间
    current_datetime = datetime.strptime(daytime,'%Y-%m-%d')
    if type=='day':
        startTime = current_datetime.strftime('%Y-%m-%d')
        endTime=current_datetime.strftime('%Y-%m-%d')
    elif type=='month':
        startTime = current_datetime.strftime('%Y-%m-01')
        endTime=current_datetime.strftime('%Y-%m-%d')
    elif type=='all':
        startTime = '2023-05-01'
        endTime=current_datetime.strftime('%Y-%m-%d')
    return startTime,endTime


# 计算时间差
def time_diff(start_time_str,end_time_str ):
    # 将字符串转换为datetime对象
    start_time = datetime.strptime(start_time_str, '%Y-%m-%d')
    end_time = datetime.strptime(end_time_str, '%Y-%m-%d')

    # 计算时间差（timedelta）
    time_difference = end_time - start_time

    # 从timedelta对象中获取天数
    days_difference = time_difference.days
    return days_difference


# sha256加密
def sha256_hash(input_string):
    # 将字符串转换为UTF-8编码
    input_bytes = input_string.encode('utf-8')
    
    # 创建SHA-256哈希对象
    sha256_hash_object = hashlib.sha256()
    
    # 更新哈希对象以处理输入字节
    sha256_hash_object.update(input_bytes)
    
    # 获取十六进制表示的哈希结果
    hashed_string = sha256_hash_object.hexdigest()
    
    return hashed_string


if __name__ == '__main__':
    
    if daytime:
    
        #获取token
        token=login()

        # 请求当月活跃数,万红发货总数,今日活跃
        month_total,dev_total,day_total=monthNumerAndDevices()

        # # 教练总数，学员总数,用户总数
        stu_total,coach_total,stucoach_total=stuAndCoachNumber()

        # 本月订单数，本月收入开普勒，本月收入服务商，本月收入教练，本月支付总额
        month_ordersNum,_,_,_,_ = recharge_record_statistics('month')
        # 全部订单数
        all_ordersNum,_,_,_,_ = recharge_record_statistics('all')

        # 当天订单数，当天收入开普勒，当天收入服务商，当天收入教练，当天支付总额
        day_ordersNum,day_kpl_income,day_facilitator_income,day_coach_income,day_income=recharge_record_statistics('day')
        
        # 结果统计:当天支付金额/当天活跃车
        # 单车当天平均产出 
        print (day_income,day_total)
        car_output=round(float(day_income)/float(day_total) ,2)
        print (car_output)
        # 单车当天平均产出-开普勒
        kpl_car_output=round(float(day_kpl_income)/float(day_total),2)
        
        # 单车当天平均产出-服务商
        facilitator_car_output=round(float(day_facilitator_income)/float(day_total),2)
        
        # 单车当天平均产出-教练
        coach_car_output=round(float(day_coach_income)/float(day_total),2)
        
        # 分成比例:
        # 开普勒实时分成比例
        kpl_scale=f'{round(float(day_kpl_income)/float(day_income),2)}%' 
        # 服务商实时分成比例
        facilitator_scale=f'{round(float(day_facilitator_income)/float(day_income),2)}%'
        # 教练实时分成比例
        coach_scale=f'{round(float(day_coach_income)/float(day_income),2)}%'
        

        ################################################################################################################
        # # 过滤车辆信息
        carInfoFiltration()
        
        # # 车辆的里程数据
        carLineNumAndTimer('all')
        
        # # 车辆的收益平台分成
        carIncomeAndScale('all')
        
        # 获取车辆绑定的用户信息
        getCarinfo()
        
        # 获取公司绑定的信息
        getCompaniesId()
        
        
        # 定义车辆标准 数量/比例
        # 初装车 
        ckd_Num=0
        ckd_Ratio=None
        # 达标车 
        cbev_Num=0
        cbev_Ratio=None
        # 僵尸车
        av_Num=0
        av_Ratio=None
        # 沉睡车
        lsv_Num=0
        lsv_Ratio=None
        # 低产车 
        lcv_Num=0
        lcv_Ratio=None   
        # 发货总数
        alltotal=len(carinfoMap)
        #今日安装总数
        todayalltotal=0
        
        

        
        
        for sn in carinfoMap:
        # 代理商信息绑定id
            id_agent=carinfoMap[sn]['id_agent']
            # 公司信息绑定id
            id_agent2=carinfoMap[sn]['id_agent2']
            # 用户绑定id
            id_company=carinfoMap[sn]['id_company']
            # 教练绑定的id
            id_bind_coach=carinfoMap[sn]['id_bind_coach']
            
            
            #############需要上传的数据
            # 绑定日期
            date_bind_coach=carinfoMap[sn]['date_bind_coach']
            # 机号 sn
            
            # 车牌
            hphm=carinfoMap[sn]['hphm']
            # 姓名
            username=userInfoBindMap[id_bind_coach]['name']
            # 电话号码 
            tel=userInfoBindMap[id_bind_coach]['tel']
            # 所属公司
            if len(id_agent2)>0:
                companyName=CompaniesMap[int(id_agent2)]['name']
            else:
                companyName=''
            # 所属代理商
            agentName = CompaniesMap[int(id_agent)]['name']
            
                        
            if sn in carLineTimerMap:
                # 里程
                lc= carLineTimerMap[sn]['lc']
                # 时长
                seconds= carLineTimerMap[sn]['seconds']
            else:
                lc=0
                seconds=0
            if sn in carIncomeScaleMap:
                # 总收益
                money= carIncomeScaleMap[sn]['money']
                # 平台分成
                earning_producer= carIncomeScaleMap[sn]['earning_producer']
                e_p=f'{round(float(earning_producer)/float(money)*100,2)}%'
                # 代理商分成
                earning_agent=carIncomeScaleMap[sn]['earning_agent']
                e_a=f'{round(float(earning_agent)/float(money)*100,2)}%'
                # 绑定教练分成
                earning_bind_coach=carIncomeScaleMap[sn]['earning_bind_coach']
                e_b=f'{round(float(earning_bind_coach)/float(money)*100,2)}%'
                # 登录教练分成
                earning_login_coach=carIncomeScaleMap[sn]['earning_login_coach']
                e_l=f'{round(float(earning_login_coach)/float(money)*100,2)}%'
                
            else:
                money=0
                earning_producer=0
                earning_agent=0
                earning_bind_coach=0
                earning_login_coach=0
                e_p='0%'
                e_a='0%'
                e_b='0%'
                e_l='0%'
        
            print(lc,seconds,money,earning_producer,date_bind_coach)
            
            ###############################
            # 标准计算
            # 绑定天数
            bindDay = time_diff(date_bind_coach,daytime)
            bindDay=1 if bindDay==0  else bindDay

            # 平台日均收入
            adr=round(float(earning_producer)/float(bindDay),2)
            
            # 日均使用时长(小时)
            adut=round(float(seconds)/float(bindDay),2)
            
            # 收入单价(元/小时)
            upi=round(float(earning_producer)/float(bindDay),2)
        
            if seconds>0:
                # 训练指数(公里/小时)
                ti=round(float(lc)/float(seconds),2)
            else:
                ti=0
        
            # 车辆所属类型
            CarType=''
            # 初装 0
            if bindDay<=7 and bindDay>0:
                CarType=0
                ckd_Num+=1 
            if bindDay==1:
                # 今日新增类型
                    todayalltotal+=1  
            # 达标车 1
            elif adr>=6:
                CarType=1
                cbev_Num+=1
            # 僵尸车 2
            elif adr<0.6 and bindDay>=30:
                CarType=2
                av_Num+=1
            # 沉睡车 3
            elif adr<3.5 and adr>=0.6 and bindDay>=30 :
                CarType=3
                lsv_Num+=1
            # 低产车 4
            else:
                CarType=4
                lcv_Num+=1
                
            # 统计的全部车辆信息
            StatisticsAllInfo.append({
                'fdeviceid':sn,
                'brand':hphm,
                'school':companyName,
                'tel':tel,
                'teacher':username,
                'banddate':date_bind_coach,
                'inc_total':money,
                'inc_kpl':earning_producer,
                'inc_server':earning_agent,
                'inc_teac':earning_bind_coach,
                'inc_teac2':earning_login_coach,
                'prop_kpl':e_p,
                'prop_serv':e_a,
                'prop_teac':e_b,
                'prop_teac2':e_l,
                'mileage':lc,
                'during':seconds,
                'ftype':CarType
            })
    
        ##########################################################         
        ##### 循环结束
        print(ckd_Num,cbev_Num,av_Num,lsv_Num,lcv_Num) 
        
        
        # ckd_Ratio= f'{round(float(ckd_Num)/float(alltotal)*100,2)}%'
        # cbev_Ratio=f'{round(float(cbev_Num)/float(alltotal)*100,2)}%'
        # av_Ratio=f'{round(float(av_Num)/float(alltotal)*100,2)}%'
        # lsv_Ratio=f'{round(float(lsv_Num)/float(alltotal)*100,2)}%'
        # lcv_Ratio=f'{round(float(lcv_Num)/float(alltotal)*100,2)}%'
        
        # print(ckd_Ratio,cbev_Ratio,av_Ratio,lsv_Ratio,lcv_Ratio) 

        StatisticsOverview={
            'ftime':daytime,
            'ship':dev_total,
            'cap_total':alltotal,
            'cap_day':todayalltotal,
            'car_month':month_total,
            'car_day':day_total,
            'mber_total':stucoach_total,
            'mber_stud':coach_total,
            'mber_teac':stu_total,
            'order_total':all_ordersNum,
            'order_month':month_ordersNum,
            'order_day':day_ordersNum,
            'avg_total':car_output,
            'avg_kpl':kpl_car_output,
            'avg_serv':facilitator_car_output,
            'avg_teac':coach_car_output,
            'inc_total':day_income,
            'inc_kpl':day_kpl_income,
            'inc_serv':day_facilitator_income,
            'inc_teac':day_coach_income,
            'ini_vehicle':ckd_Num,
            'sta_vehicle':cbev_Num,
            'low_vehicle':lcv_Num,
            'sle_vehicle':lsv_Num,
            'frz_vehicle':av_Num,
            'vehicle_total':alltotal,
        }
        
        # 车辆信息
        updata_server('baseinfo',{'list':StatisticsAllInfo})
        
        # 统计信息
        updata_server('static',StatisticsOverview)
    else:
        print("请传递参数！！")